---
collections: 
    - name: documents
      next: docs/getting-started/installation-and-requirements
layout: dm:document
next: docs/getting-started/installation-and-requirements
parent: docs/getting-started/index
title: Resonance's Goals and Principles
description: >
    Learn the framework's main principles and long-term goals.
---

# Resonance's Goals and Principles

## Advocacy for Asynchronous PHP

Asynchronous PHP is the future of the language since it changes how we can use 
PHP. Instead of just a website generator, it becomes the communication hub 
between infrastructure services.

Creating basic and standard features like authentication, authorization, blog 
pages, and others is effortless in PHP. It's also easy to prototype in PHP.

This framework aims to provide ease of creation and development and treat PHP 
as an entry point to your internal services.

You can easily create and prototype features in PHP. Then, if the need arises, 
you can easily replace parts of your applications with services written in 
different languages or with API calls.

## General Long-Term Goals

Resonance strives to provide:

1. consistent speed of development, no matter the size of the project
1. ease of maintenance
1. ease of integration with external services

We regard the commitment to performance and security as a baseline and 
something that should be obvious in modern development practices and 
therefore, we do not present them as our distinct values.
